/*
	LC-8600V[Yp fJ[hCl[u

	1997.2.2	Y.Kawakami
	1997.4.14	Ver.1.21 /D XCb`ǉ
	1997.7.19	Ver.1.22 J[h̃^C~OύX
	1997.9.23	Ver.1.23 card_on̑Ocard_disables
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<dos.h>
#include	<io.h>
#include	<conio.h>
#include	<time.h>

#define		TRUE		1
#define		FALSE		0
#define		USAGE		0
#define		CARD_OFF	1
#define		CARD_ON		2

struct CIS {
	unsigned int	ccor;
	unsigned char	ccsr_flag;
	unsigned char	func;
	unsigned char	config_index_offset;
	unsigned char	puls_flag;
	char		name[256];
} Cis;

unsigned int	Patch_adrs=0;
int		Init_wait=12;
int		Default_modem=0;

int set_card_timer( int tm );
void timer(void);
unsigned int search_patch( void );
int reset_patch(void);
int set_patch(void);
void bios_patch( unsigned int adrs, unsigned char d );
int analysys_cis( unsigned char *buff, struct CIS *cis );
int card_on( int com, int irq );
int card_off(void);
void usage(void);
void disable_card(void);
void set_iowindow( unsigned int adrs, int n, unsigned int data );
int init_card();
unsigned int open_cis(void);
void close_cis(unsigned int old_a3);
int read_SDATA( int n );
int read_CREG( int n );
void write_CREG( int n, int data );
void eprint( char * );
void print( char *mes );
void _asm_( char * );

int main( int argc, char *argv[] )
{
int		i,job;
char		buff[256],*p;
int		irq,com;


	printf("Lexicomp LC-8600 Series MODEM CARD Enabler Version 1.23\n");
	printf("Copyright(C)JR0DBK Yuki,1997\n");
	irq=0;
	com=3;
	job=USAGE;

	for (i=1; i<argc; i++){
		strcpy(buff, argv[i]);
		strupr(buff);
		p = buff;
		if (*p=='?'){
			job=USAGE;
		} else if ((*p=='/')||(*p=='-')){
			++p;
			switch(*p++){
				case 'C':
					com=(*p)-'0';
					if ((com!=1)&&(com!=3)&&(com!=4)){
					    eprint("COM port Error.");
					    com=3;
					    job=USAGE;
					}
					break;
				case 'I':
					irq=(*p)-'0';
					if ((irq<1)||(irq>7)){
					    eprint("IRQ Error.");
					    irq=7;
					    job=USAGE;
					}
					break;
				case 'O':
					if (*p=='N'){
						job=CARD_ON;
					} else if (*p=='F'){
						job=CARD_OFF;
					}
					break;
				case 'W':
					Init_wait=atoi(p);
					if ((Init_wait<0)||
					    (Init_wait>20))
						Init_wait=12;
					break;
				case 'X':
					break;
				case 'D':
					Default_modem=2;
					break;
				default:
					job=USAGE;
					break;
			}
		} else if ( strcmp(buff, "ON" )==0 ){
			job=CARD_ON;
		} else if ( strcmp(buff, "OFF" )==0 ){
			job=CARD_OFF;
		}
	}

	if ( irq==0 ){
		if ( com==1 ){
			irq=4;
		} else if ( com==3 ){
			irq=7;
		} else if ( com==4 ){
			irq=7;
		}
	}
	switch(job){
		case CARD_ON:
			Patch_adrs = search_patch();
			disable_card();
			return card_on( com, irq );
		case CARD_OFF:
			Patch_adrs = search_patch();
			return card_off();
		default:
			usage();
			return 0;
	}
}


void usage(void)
{
	printf("fJ[hCl[u܂B\n");
	printf("IvVXCb`:\n");
	printf("\tON\tJ[hgpɂ܂B\n");
	printf("\tOFF\tJ[hgpsɂ܂B\n");
	printf("\t-Cn\tCOM|[g nɂ܂B(n=1,3,4)\n");
	printf("\t-In\tIRQ nɂ܂B(n=2,4,5,6,7)\n");
	printf("\t-D\tftHgŃfJ[hƂ݂Ȃ܂B\n");
	printf("\t-?,-H\t̃wv\܂B\n");
	printf("ftHg COM3, IRQ7łB\n");
}


int card_on( int com, int irq )
{
int		i;
unsigned char	buff[512];
unsigned char	far *adrs;
unsigned int	ioadrs,old_a3;

	/* BIOSpb`Ă猳ɖ߂ */

	reset_patch();

	if ( (read_SDATA(0x0a)&0x0c) != 0x00 ){
		eprint("No CARD.");
		return 1;
	}

	if ( init_card() ){
		eprint("\nCARD init Error");
		return 1;
	}

	adrs = MK_FP( 0xe000, 0 );	/* CIS̓ǂ݂ */
	memset(buff, 0, 512);
	di();
	old_a3 = open_cis();
	for (i=0; i<256; i++){
		buff[i]=*adrs++;
		adrs++;
	}
	close_cis( old_a3 );
	ei();

	analysys_cis( buff, &Cis );

	if ( Cis.name[0] != 0 ){
		print("CARD name:");
		print( Cis.name );
		print("\n");
	}

	if ( Cis.func != 2 ){
		eprint("Not found MODEM CARD.");
		disable_card();
		return 1;
	}
	if (( Cis.ccor == 0 )||
	    ( Cis.config_index_offset == -1 )){
		eprint("CARD Configration Error.");
		disable_card();
		return 1;
	}

	/* BIOSɃpb`ĂăJ[hd؂Ȃ悤ɂ */

	if ( set_patch() ){
		eprint("Not found Patch address.");
		disable_card();
		return 1;
	}


	/* I/OEBhẼI[v */

	if (com==1){
		ioadrs=0x03f8;
		write_CREG( 0x0f, 0x0a );	/* UART֎~ */
	} else if (com==4){
		ioadrs=0x02e8;
	} else {
		ioadrs=0x03e8;
	}
	set_iowindow( ioadrs, 8, 0x42 );


	write_CREG( 0x46, 0x20 );		/* PCMCIA I/O Enable */
	write_CREG( 0x42, 0x80+irq );			/* CARD IRQ */
	write_CREG( 0x40, read_CREG(0x40)|0x80 );	/* SPKRA=1 */


	timer();	/* 100mS wait */


	/* J[hCl[u */

	adrs = MK_FP( 0xe000, Cis.ccor );
	di();
	old_a3 = open_cis();
	if ( Cis.puls_flag ){
		*adrs++ = Cis.config_index_offset+com-1;
	} else {
		*adrs++ = 0x40+Cis.config_index_offset+com-1;
	}
			/* COMԍߑłĂ */
	if (Cis.ccsr_flag){
		adrs++;
		adrs++;
		adrs++;
		*adrs=0x08;
	}
	close_cis( old_a3 );
	ei();


	/* COM|[g[NGAZbg */

	adrs = MK_FP( 0x0040, (com-1)*2 );
	di();
	*adrs++ = ioadrs;
	*adrs   = ioadrs>>8;
	ei();

	print("Enabled.\n");

	return 0;
}


int card_off(void)
{
	disable_card();
	print("Disabled.\n");
	return 0;
}


/* J[h̏ */
int init_card()
{
int		i;
union REGS	reg;

	if ((inp(0x370)&2)==0){
		for (i=0; i<Init_wait; i++){	/* HDDVbsO҂ */
			timer();
			timer();
			print(".");
		}
	}

	reg.x.ax = 0x8700;	   /* CARD POWER ON ? */
	reg.x.bx = 0x0000;	   /* J[hɂĂ͂Ȃ */
	int86( 0x1f, &reg, &reg ); /*u HDD̓d */

	write_CREG( 0x90, 0x40 );
	timer();
 	write_CREG( 0x90, 0x60 );

	timer();

	i = 0;
	while((read_SDATA(0x0a) & 0x10)==0){
		timer();
		timer();
		print(".");
		if (++i > 50){
			print("\r");
			return 1;
		}
	}
	print("\r");
	return 0;
}


void disable_card(void)
{
unsigned int	far *adrs;

	/* BIOSpb`ɖ߂ */

	if ( reset_patch() ){
		eprint("Not found Patch address.");
	}

	write_CREG( 0x40, read_CREG(0x40)&0x7f );	/* SPKRA=0 */
	write_CREG( 0x42, 0x00 );		/* CARD IRQ off */
	adrs = MK_FP( 0x0040, 0x0004 );
	*adrs++ = 0;				/* COM3 */
	*adrs   = 0;				/* COM4 */
	set_iowindow( 0x03f8, 8, 0x02 );	/* COM1 */
	set_iowindow( 0x03e8, 8, 0x02 );	/* COM3 */
	set_iowindow( 0x02e8, 8, 0x02 );	/* COM4 */
	write_CREG( 0x0f, 0x0b );		/* UART COM1 */

	set_card_timer( 10 );

	timer();
}


int analysys_cis( unsigned char *buff, struct CIS *cis )
{
unsigned char	*p,*np,c,f;
unsigned int	code;
int		i,len;

	f = 2;
	memset( cis, 0, sizeof(struct CIS) );
	cis->config_index_offset = -1;
	cis->func = Default_modem;

	p = buff;
	for (;;){
		code = *p++;
		if ((code == 0x00ff)||(code==0))
			break;
		len = *p++;
		np = p+len;
		switch( code ){
			case 0x21:		/* t@NV ID */
				f = *p;
				if ( f == 2 ){
					cis->func = f;
				}
				break;
			case 0x1a:		/* RtBM[V */
				if ( f == 2 ){
					p++;
					p++;
					cis->ccor = *p++;
					cis->ccor += (*p++)<<8;
					if (*p & 2){
						cis->ccsr_flag=TRUE;
					}
				}
				break;
			case 0x1b: /* RtBM[VGg[*/
				if (( f == 2 )
				  &&(cis->config_index_offset == -1)){
					cis->config_index_offset
						= *p & 0x3f;
					for (;p<np;p++){
						if (*p==0xf8){
						    p++;
						    if (*p==0x03){
							p++;
							p++;
							cis->puls_flag
							    = (*p & 0x20)^0x20;
							break;
						    }
						}
					}
				}
				break;
			case 0x15:		/* i */
				p++;
				p++;
				for (i=0;i<len-2;i++){
					c=*p++;
					if (c<0x20)	c=0x20;
					if (c==0xff)	c=0x20;
					cis->name[i] = c;
				}
				cis->name[i] = 0;
				break;
			default:
				break;
		}
		p = np;		/* ̃^v */
	}
	return 0;
}


void set_iowindow( unsigned int adrs, int n, unsigned int data )
{
int		i;
union REGS	reg;

	for (i=0; i<n; i++){
		reg.h.ah = 0x15;
		reg.h.bl = 1;
		reg.x.dx = i+0x0100+adrs;
		reg.h.al = (unsigned char)data;
		int86( 0x1f, &reg, &reg );
		reg.h.ah = 0x15;
		reg.h.bl = 1;
		reg.x.dx = i+0x0500+adrs;
		reg.h.al = (unsigned char)data;
		int86( 0x1f, &reg, &reg );
	}
}


unsigned int open_cis(void)
{
union REGS	reg;

	write_CREG( 0x26, 0xce );
	reg.h.ah = 0x14;
	reg.x.bx = 0xa300;
	int86( 0x1f, &reg, &reg );
	write_CREG( 0xaf, 0x08 );
	write_CREG( 0xa3, 0x00 );

	return reg.x.ax;
}


void close_cis(unsigned int old_a3)
{
	write_CREG( 0xaf, old_a3>>8 );
	write_CREG( 0xa3, old_a3 );
	write_CREG( 0x26, 0xee );

}


/* WG[o */
void eprint( char *mes )
{
	fprintf(stderr, "%s\x07\n", mes);
}


/* Ctrl+C `FbNȂ\ */
void print( char *mes )
{
union REGS	reg;
char		c;

	while( c = *mes++ ){
		if ( c=='\n' ){
			reg.h.ah = 6;
			reg.h.dl = 13;
			int86( 0x21, &reg, &reg );
		}
		reg.h.ah = 6;
		reg.h.dl = c;
		int86( 0x21, &reg, &reg );
	}
}


int read_SDATA( int n )
{
union REGS	reg;

	reg.h.ah = 0x07;
	reg.h.al = (unsigned char)n;
	int86( 0x1f, &reg, &reg );
	return (int)reg.h.al;
}


int read_CREG( int n )
{
union REGS	reg;

	reg.h.ah = 0x14;
	reg.h.bl = 0;
	reg.h.bh = (unsigned char)n;
	int86( 0x1f, &reg, &reg );
	reg.h.ah = 0;
	return reg.x.ax;
}


void write_CREG( int n, int data )
{
union REGS	reg;

	reg.h.ah = 0x14;
	reg.h.bl = 1;
	reg.h.bh = (unsigned char)n;
	reg.h.al = (unsigned char)data;
	int86( 0x1f, &reg, &reg );
}


void bios_patch( unsigned int adrs, unsigned char d )
{
unsigned char	far	*ad;

	write_CREG( 0xcf, read_CREG(0xcf)&0xf7 );

	ad = MK_FP( 0xf000, adrs );
	*ad = d;

	write_CREG( 0xcf, read_CREG(0xcf)|0x08 );
}


/* BIOSpb`ĕ */
unsigned int search_patch( void )
{
unsigned char	far *adrs, far *p;
unsigned int	i,sub,call;

	sub = 0;
	adrs = MK_FP( 0xf000, 0 );
	for (i=0; i<0x8000; i++){
		if ( *adrs == 0x52 ){
			p = adrs;
			p++;
			if ((*p++==0xBA)&&(*p++==0x70)&&(*p++==0x03)
			  &&(*p++==0x02)&&(*p++==0xD0)&&(*p++==0xEC)
			  &&(*p++==0x22)&&(*p++==0xC3)&&(*p++==0x0A)
			  &&(*p++==0xC7)&&(*p++==0xEE)&&(*p++==0x5A)
			  &&(*p++==0xC3)){
				sub = i;
				break;
			}
		}
		adrs++;
	}
	if ( sub==0 ){
		return 0;
	}

	adrs = MK_FP( 0xf000, 0 );
	for (i=0; i<0x8000; i++){
		if ( *adrs == 0xBB ){
			p = adrs;
			p++;
			if ((*p++==0xFD)&&(*p++==0x00)&&(*p++==0xB0)
			  &&(*p++==0x00)&&(*p++==0xE8)){
				call = *p++;
				call += (*p++)<<8;
				if (sub==(call+(unsigned int)p))
					return i-17;
			}
		}
		adrs++;
	}

	return 0;
}


int set_patch(void)
{
unsigned int	ad;
unsigned char	far *adrs;

	ad = Patch_adrs;
	if ( ad==0 ){
		return 1;
	} else {
		adrs = MK_FP( 0xf000, ad );
		if ((*adrs++==0xa8)&&(*adrs==0x08)){
			bios_patch( ad+1, 0 );	/* TEST AL,0 */
		}
		return 0;
	}
}


int reset_patch(void)
{
unsigned char	far *adrs;
unsigned int	ad;

	ad = Patch_adrs;
	if ( ad==0 ){
		return 1;
	} else {
		adrs = MK_FP( 0xf000, ad );
		if ((*adrs++==0xa8)&&(*adrs==0)){
			bios_patch( ad+1, 0x08 );	/* TEST AL,8 */
		}
	}

	return 0;
}


int set_card_timer( int tm )
{
unsigned char	far *adrs;
unsigned int	ad;

	ad = Patch_adrs;
	if ( ad==0 ){
		return 1;
	}

	adrs = MK_FP( 0xf000, ad );
	if ( *adrs++ != 0xa8 ){
		return 1;
	}
	adrs++;
	adrs++;
	adrs++;
	if ((*adrs++==0xff)&&(*adrs++==0x0e)){
		ad = *adrs++;
		ad += (*adrs)<<8;
		di();
		bios_patch( ad++, (unsigned char)tm );
		bios_patch( ad, (unsigned char)(tm>>8) );
		ei();
	}

	return 0;
}


/* 100mS WAIT */
void timer(void)
{
int		i;
unsigned int	tm;
union REGS	reg;

	for (i=0; i<2; i++ ){
		reg.h.ah = 0;
		int86( 0x1a, &reg, &reg );
		tm = reg.x.dx;
		do {
			reg.h.ah = 0;
			int86( 0x1a, &reg, &reg );
		} while( tm == reg.x.dx );
	}
}


